#ifndef NCTASK_H_
#define NCTASK_H_

#include <pthread.h>
#include <stdbool.h>
#include <stdint.h>

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct tTask
{
	bool (*pfnInit)(void* p);
	void* (*pfnRun)(void* unused);
	bool (*pfnShutdown)(void);
	pthread_t thread;
} Task;

extern Task g_tasks[];
extern uint8_t g_numberOfTasks;

Task * TaskGet(uint8_t index);
bool TaskInitAll(void* p);
void TaskRunAll(void* p);
void TaskShutdownAll();

#ifdef __cplusplus
}
#endif

#endif /* NCTASK_H_ */
