#ifndef CONFIGESSENTIALS_H_
#define CONFIGESSENTIALS_H_

#include "Serializer.h"
#include "NcString.h"


#include <stdint.h>
#include <termios.h>
#include "NcClosers.h"
#include "Serializer.h"
#include "NcString.h"

#define CONFIG_SERIALIZER_JSON "json"
#define CONFIG_SERIALIZER_XML "xml"

typedef class tConfigEssentials
{
	ISerializer * _serializer;
	const char * _serializerName;
	const char * _delimiter;
	char * _delimiterFormatted;
	

public:
	virtual ~tConfigEssentials() {}
	virtual ISerializer * getSerializer() { return _serializer; }
	virtual void setSerializer(ISerializer * v) { _serializer = v; }
	virtual const char * getSerializerName() { return _serializerName; }
	virtual void setSerializerName(const char * v) { _serializerName = v; }
	virtual const char * getDelimiter(){return _delimiter;}
	virtual void setDelimiter(const char * v)
	{
		_delimiter = v;
		Free((void**)&_delimiterFormatted);
		_delimiterFormatted = StringUnEscape(v);
	}
	virtual const char * getDelimiterFormatted() { return _delimiterFormatted; }
	
	tConfigEssentials()
	{
		_delimiter = 0;
		_serializer = 0;
		_serializerName = 0;
		_delimiterFormatted = 0;
	}
} ConfigEssentials;


extern bool SetSerializer(const char * ser, ConfigEssentials * conf_essentials);


#if !_WIN32 && !_WIN64 // Exclude this when target is a Windows platform
#include "Configuration.h"
#endif


#endif /* CONFIGESSENTIALS_H_ */
