#include <stdio.h>
#include <string.h>
#include "RecvEssentials.h"
#include "NcApi.h"
#include "NeoParser.h"


extern void DispatchFormattedMsg(const char * m);

RecvState g_recv;


void RecvTaskInitEssentials(ConfigEssentials * c)
{
	memset(&g_recv, 0, sizeof(g_recv));
	g_recv.config_ser = c;
}

void UartReadCallback(uint8_t n, uint8_t * msg, uint8_t msgLength)
{

	if (msgLength!=0)
	{
		switch(msg[0x00])
		{
		case HostAckEnum:
		case HostNAckEnum:
		case HostDataEnum:
		case HostDataHapaEnum:
		case HostUappDataEnum:
		case HostUappDataHapaEnum:
		case NodeInfoReplyEnum:
		case NeighborListReplyEnum:
		case NetCmdReplyEnum:
		case WesStatusEnum:
		case WesSetupRequestEnum:
			break;
		default:
			{
#ifdef GATEWAY_DEBUG_INFORMATION
				printf("    - interpreted as raw data format \r\n");
#endif
				DispatchFormattedMsg( g_recv.config_ser->getSerializer()->SerializeRaw(msg,msgLength) );
				break;
			}
		}
	}
}

void UartHostAckCallback(uint8_t n, tNcApiHostAckNack * p)
{
	DispatchFormattedMsg( g_recv.config_ser->getSerializer()->SerializeAck(p) );
}

void UartHostNAckCallback(uint8_t n, tNcApiHostAckNack * p)
{
	DispatchFormattedMsg( g_recv.config_ser->getSerializer()->SerializeNAck(p) );
}

void UartHostDataCallback(uint8_t n, tNcApiHostData * p)
{
	DispatchFormattedMsg( g_recv.config_ser->getSerializer()->Serialize(p) );
}

void UartHostDataHapaCallback(uint8_t n, tNcApiHostDataHapa * p)
{
	DispatchFormattedMsg( g_recv.config_ser->getSerializer()->Serialize(p) );
}

void UartHostUappDataCallback(uint8_t n, tNcApiHostUappData * p)
{
	DispatchFormattedMsg( g_recv.config_ser->getSerializer()->Serialize(p) );
}

void UartHostUappDataHapaCallback(uint8_t n, tNcApiHostUappDataHapa * p)
{
	DispatchFormattedMsg( g_recv.config_ser->getSerializer()->Serialize(p) );
}

void UartNodeInfoReplyCallback(uint8_t n, tNcApiNodeInfoReply * p)
{
	DispatchFormattedMsg( g_recv.config_ser->getSerializer()->Serialize(p) );
}

void UartNeighborListReplyCallback(uint8_t n, tNcApiNeighborListReply * p)
{
	DispatchFormattedMsg( g_recv.config_ser->getSerializer()->Serialize(p) );
}

void UartNetCmdReplyCallback(uint8_t n, tNcApiNetCmdReply * p)
{
	DispatchFormattedMsg( g_recv.config_ser->getSerializer()->Serialize(p) );
}

void UartWesSetupRequestCallback(uint8_t n, tNcApiWesSetupRequest * p)
{
	DispatchFormattedMsg( g_recv.config_ser->getSerializer()->Serialize(p) );
}

void UartWesStatusCallback(uint8_t n, tNcApiWesStatus * p)
{
	DispatchFormattedMsg( g_recv.config_ser->getSerializer()->Serialize(p) );
}
