#ifndef SEND_ESSENTIALS_H_
#define SEND_ESSENTIALS_H_



#include "ConfigEssentials.h"
#include "NcApi.h"
#include "NeoParser.h"



#if !_WIN32 && !_WIN64
#include <termios.h>
#include <netdb.h>
#include <vector>
#endif

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct tSendState
{
	int fd;
	tConfigEssentials * config_ser;
#if !_WIN32 && !_WIN64 // Exclude this when target is a Windows platform
    tSendConfig * config;
	volatile TaskRunEnum state;
	int socketFd;
	struct sockaddr_in address;
#endif
	int clientFd;
	uint8_t * clientRaw;
	int clientRawLen;
	char * clientMsg;
	int clientMsgLen;
	NcApiMessageType ncApiType;
	tNcApiSendUnackParams ncSendUnackParams;
	tNcApiSendAckParams ncSendAckParams;
	tNcApiNodeInfoParams ncNodeInfoParams;
	tNcApiNeighborListRequestParams ncNeighborListParams;
	tNcApiNetCmdParams ncNetCmdParams;
	tNcApiWesCmdParams ncWesCmd;
	tNcApiWesResponseParams ncWesResponse;
	tNcApiAltCmdParams ncAltCmd;
	volatile bool msgWasWritten;
} SendState;

extern SendState g_send;

extern void SendTaskInitEssentials(ConfigEssentials * c);

extern const char* ParseMsg();
extern void PrintMsg();
extern NcApiErrorCodes  SendMessageToNcApi();

#ifdef __cplusplus
}
#endif

#endif /* SEND_ESSENTIALS_H_ */
