#ifndef SERIALIZATION_H_
#define SERIALIZATION_H_

#include "NcApi.h"
#include "Messages.h"

// Define pure virtual serializer functions to be implemented for the actual format,
// for example JSON, XML, or similar.
typedef class tSerializer
{
public:
	virtual ~tSerializer() {}

	virtual const char * DeSerialize(const char * m, int len, tNcApiSendUnackMessage * msg) = 0;
	virtual const char * DeSerialize(const char * m, int len, tNcApiSendAckMessage * msg) = 0;
	virtual const char * DeSerialize(const char * m, int len, tNcApiNodeInfoRequestMessage * msg) = 0;
	virtual const char * DeSerialize(const char * m, int len, tNcApiNeighborListRequestMessage * msg) = 0;
	virtual const char * DeSerialize(const char * m, int len, tNcApiNetCmdMessage * msg) = 0;
	virtual const char * DeSerialize(const char * m, int len, tNcApiWesCmdMessage * msg) = 0;
	virtual const char * DeSerialize(const char * m, int len, tNcApiWesResponseMessage * msg) = 0;
	virtual const char * DeSerialize(const char * m, int len, tNcApiAltCmdMessage * msg) = 0;

	virtual const char * SerializeAck(tNcApiHostAckNack * p) = 0;
	virtual const char * SerializeNAck(tNcApiHostAckNack * p) = 0;
	virtual const char * SerializeRaw(uint8_t * Buffer,uint8_t payloadLength) = 0;
	virtual const char * Serialize(tNcApiHostData * p) = 0;
	virtual const char * Serialize(tNcApiHostDataHapa * p) = 0;
	virtual const char * Serialize(tNcApiHostUappData * p) = 0;
	virtual const char * Serialize(tNcApiHostUappDataHapa * p) = 0;
	virtual const char * Serialize(tNcApiNodeInfoReply * p) = 0;
	virtual const char * Serialize(tNcApiNeighborListReply * p) = 0;
	virtual const char * Serialize(tNcApiNetCmdReply * p) = 0;
	virtual const char * Serialize(tNcApiWesSetupRequest * p) = 0;
	virtual const char * Serialize(tNcApiWesStatus * p) = 0;
	virtual const char * Serialize(ReplyMsg * p) = 0;
} ISerializer;

#endif /* SERIALIZATION_H_ */
